
#include <LiquidCrystal_I2C_Spark.h>
#include <MQTT.h>

#define HOST_PORT 1883 //port# used by host (IBM Watson IoT Platform): 1883 (default)

#define MQTT_QoS 0 //MQTT QoS = 0: message will be delivered zero or once (default)

char *MQTT_HOST = "ruiar7.messaging.internetofthings.ibmcloud.com";
char *MQTT_CLIENT = "d:ruiar7:Microcontroller:Particle";

char *MQTT_USERNAME = "use-token-auth";
char *MQTT_PASSWORD = "smartiotsprinkler";

char *MESSAGE_TOPIC = "iot-2/evt/testdata/fmt/json"; // Segment can be customized by you
char *MESSAGE_TOPIC1 = "iot-2/evt/testdata1/fmt/json"; // Segment can be customized by you

MQTT client( MQTT_HOST, HOST_PORT, callback ); //Create a MQTT client for your device 



int testdata = 0;
int IndicatorLed = D7;
char payload[80]; //MQTT message's payload. A string in JASON format.
                  // 80Bytes used here. Change the size according to your data.
                  

/**************************************************************************************************/
/*****************************Global Variables and Function Prototypes*****************************/ 
        
int TemperatureSensor = A0;     //Assigns the variable TemperatureSensor to Analog Pin A0
double Temperature_C;           //This variable will hold the temperature value in  °C
double Temperature_F;           //This variable will hold the temperature value in  °F



int MoistureSensor = A5;         //Assigns the variable MoistureSensor to Analog Pin A5
int MoistureSensorVal;          //This variable will hold the analog value
String MoistureState;           
int SolenoidValve = D6;         //Assigns the variable SolenoidValve to Digital Pin D4
                                //This Solenoid is normally closed
LiquidCrystal_I2C *lcd;         //Creates an instance of a LiquidCrystal_I2C object



int blueLED = D2;
int brightness = 0;    // how bright the LED is
int fadeAmount = 5;


//Function Prototypes
int serialPrintTemperature();
int printTemperature(String command);
void soilMoistureState(int &);
void serialPrintMoisture();
void openValve();
/**************************************************************************************************/
 
 
 
 
 
 
 
 
 
 
 
void setup() {
    
    //IBM WATSON IOT PLATFORM SETUP
        pinMode(IndicatorLed, OUTPUT);
        Serial.begin( 9600 ); //Use serial monitor to debug the code.
     
 
 
    lcd = new LiquidCrystal_I2C(0x27, 16, 2);       //Connect SDA->D0   SCL->D1
    lcd->init();
    lcd->backlight();
    lcd->clear();
    
    
    
    
    
    Particle.variable("TemperatureC", &Temperature_C, DOUBLE);
    Particle.variable("TemperatureF", &Temperature_F, DOUBLE);
    
    Particle.function("TempDisplay", printTemperature);
    
    Particle.variable("SoilMoisture", &MoistureState, STRING);
    
    pinMode(TemperatureSensor,INPUT);   //Sets the Analog Pin A0 as Input
    pinMode(MoistureSensor,INPUT);      //Sets the Analog Pin A5 as Input
    pinMode(SolenoidValve, OUTPUT);     //Sets the Digital Pin 2 as Output
    
    pinMode(blueLED,OUTPUT);
 
    //Read “Particle serial tutorial” for detailed how-to.
        Serial.println( "Connecting Photon to IBM Watson IoT Platform ...... " );
         while( !Serial.available() ) {
         Particle.process();
         }
        client.connect(MQTT_CLIENT,MQTT_USERNAME,MQTT_PASSWORD);//Connect Photon to Watson IoT Platform
         if( client.isConnected() ) { //Verify the connection
         Serial.println( "Now connected!" );
         // client.subscribe( MQTT_SUBSCRIBE ); //This sample code is only to send data to cloud,
         //not subscribe from cloud, so this line is commented out.
          }
 
 
}
void loop() {
    

    
        //Equations used for Conversion of Analog Reading to Temperature
            //Voltage at Analog Pin (milliVolts) = (reading from ADC) * (3300/1024)
            //Centigrade Temperature = [(Analog Voltage in mV) - 500] / 10
        
    
        //Temperature_C= ( (analogRead(TemperatureSensor)*(3300/1024)) -500) /10 ;    
        Temperature_C=map(analogRead(TemperatureSensor),0,4094,0,100);
        Temperature_F=  Temperature_C*(9/5) + 32;
        printTemperature("serial");           //Outputs Temperature onto Serial Monitor 
        
        MoistureSensorVal= analogRead(MoistureSensor);
        soilMoistureState(MoistureSensorVal);
       
        delay(200);
        openValve();
        lcd->clear();
        lcd->setCursor(0 ,0);
        lcd->print("Temp Deg F:");
        lcd->println(Temperature_F);
        lcd->setCursor(0 ,1);
        lcd->print("Soil:");
        lcd->print(MoistureState);
        
        Serial.println(analogRead(TemperatureSensor));
        
        //BLUE LED
        analogWrite(blueLED, brightness);
        brightness = brightness + fadeAmount;
        
       if (brightness <= 0 || brightness >= 255) { 
        fadeAmount = -fadeAmount;
        }
        //BLUE LED ENDS
    
    
    
    
    
    
    
    /**************************************************************************************************/
    /************************************************MQTT**********************************************/
     testdata = Temperature_C;
     //Convert data to a JSON format string on line66:
     //JSON format example: {“property”: value1, ”property2”: value2,...}
     sprintf(payload, "{ \"testdata\": \"%d\" }", testdata);
    
     //send the JSON formatted payload (including the data) to Watson under the pre-defined topic
     client.publish(MESSAGE_TOPIC, const_cast<char*> (payload) );
    
     digitalWrite(IndicatorLed, HIGH); //Quickly blink the LED D7 once when a data is sent
     delay(100);
     digitalWrite(IndicatorLed, LOW);
     delay(100);
    
     client.loop();
     Serial.print( "Data being sent to Cloud: " ); //Display the sent data on SerialMonitor
     Serial.println(testdata);
     delay( 3000 ); //Set the period of sending data
    /**************************************************************************************************/
    
     
     

}

    /**************************************************************************************************/
    /**************************************************************************************************/

/***********************************Serial Output Temperature***********************************/
int serialPrintTemperature() {
    
    Serial.print("The Temperature is ");
    Serial.print(Temperature_C);
    Serial.print(" °C ");
    Serial.print(Temperature_F);
    Serial.println(" °F ");
    
    
    return 0;
    
}
/***********************************************************************************************/



/*************************************Cloud Function Temp *************************************/
int printTemperature(String command){
    
    if (command=="cloud"){
    
    Particle.publish("Temperature in Centigrade:",String(Temperature_C) );
    Particle.publish("Temperature in Fahrenheit:",String(Temperature_F) );
    digitalWrite(SolenoidValve, HIGH);
         
    
    }
    
    if(command=="serial"){
        serialPrintTemperature();
    }
    
    return 0;
    
}
/***********************************************************************************************/




/*******************************Determines the Soil Moisture************************************/
void soilMoistureState(int &MoistureSensorVal){
    
    if(MoistureSensorVal<=300){
            MoistureState="Dry";
    }
        
        if(MoistureSensorVal>300 && MoistureSensorVal<=700){
            MoistureState="Humid";
        }
            
        if(MoistureSensorVal>700 && MoistureSensorVal<=950){
            MoistureState="Saturated";
        }
            
            
    }
    
    
/***********************************************************************************************/



/*********************************Serial Output Soil Moisture***********************************/
void serialPrintMoisture(){
    
    Serial.print("The Soil Moisture is ");
    Serial.println(MoistureState);
    
}
/***********************************************************************************************/


/*********************************Activate the Solenoid Vale************************************/
void openValve(){
    
    if( (MoistureState=="Dry" && Temperature_F>85) ){
         digitalWrite(SolenoidValve, HIGH);
         
         lcd->clear();
         lcd->setCursor(0 ,0);
         lcd->print("    SOLENOID ");
         lcd->setCursor(0 ,1);
         lcd->print("   ACTIVATED ");
         delay(10000);
        
         digitalWrite(SolenoidValve, LOW);
         
         
         lcd->clear();
         lcd->setCursor(0 ,0);
         lcd->print("    SOLENOID ");
         lcd->setCursor(0 ,1);
         lcd->print("  DEACTIVATED ");
         delay(1000);
    }

    
    
}

/***********************************************************************************************/







//IBM WATSON IOT PLATOFORM CALLBACK FUNCTION
void callback( char* topic, byte* payload, unsigned int length ) {
 char p[length + 1];

 memcpy( p, payload, length );
 p[length] = NULL;

 String message( p );
 
 
}








